HDU 1026 Ignatius and the Princess I (bfs+手写队列保存路径)

来源:互联网 发布:手机淘宝里怎么开网店 编辑:程序博客网 时间:2024/06/06 07:27

                                                                                 Ignatius and the Princess I 
Problem Description
The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166's room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them, he has to kill them. Here is some rules:

1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).
2.The array is marked with some characters and numbers. We define them like this:
. : The place where Ignatius can walk on.
X : The place is a trap, Ignatius should not walk on it.
n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.

Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position.
 

Input
The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole labyrinth. The input is terminated by the end of file. More details in the Sample Input.
 

Output
For each test case, you should output "God please help our poor hero." if Ignatius can't reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output.
 

Sample Input
5 6.XX.1...X.2.2...X....XX.XXXXX.5 6.XX.1...X.2.2...X....XX.XXXXX15 6.XX.....XX1.2...X....XX.XXXXX.
 

Sample Output
It takes 13 seconds to reach the target position, let me show you the way.1s:(0,0)->(1,0)2s:(1,0)->(1,1)3s:(1,1)->(2,1)4s:(2,1)->(2,2)5s:(2,2)->(2,3)6s:(2,3)->(1,3)7s:(1,3)->(1,4)8s:FIGHT AT (1,4)9s:FIGHT AT (1,4)10s:(1,4)->(1,5)11s:(1,5)->(2,5)12s:(2,5)->(3,5)13s:(3,5)->(4,5)FINISHIt takes 14 seconds to reach the target position, let me show you the way.1s:(0,0)->(1,0)2s:(1,0)->(1,1)3s:(1,1)->(2,1)4s:(2,1)->(2,2)5s:(2,2)->(2,3)6s:(2,3)->(1,3)7s:(1,3)->(1,4)8s:FIGHT AT (1,4)9s:FIGHT AT (1,4)10s:(1,4)->(1,5)11s:(1,5)->(2,5)12s:(2,5)->(3,5)13s:(3,5)->(4,5)14s:FIGHT AT (4,5)FINISHGod please help our poor hero.FINISH

解题思路:

由于要输出路径,stl的队列不方便,所以要手写一个队列来保存路径,要注意每到一个有怪兽的地方特判,字符大于‘0’就压入队列,并把字符--,continue。。这题写完也用了不久。。就是粗心没注意到带入递归求路径的x应该为head而不是tail-1。。。卡了一下午

代码:

#include<algorithm>#include<iostream>#include<cstring>#include<cstdio>#include<math.h>#include<string>#include<stdio.h>#include<queue>#include<stack>using namespace std;struct node{    int x,y;    int time;    int pre;};node qu[100005];int dirx[4]={0,0,-1,1};int diry[4]={-1,1,0,0};int head,tail;struct que{    que()    {        head=0;        tail=0;    }    void push(node t)    {        qu[tail]=t;        tail++;    }    bool empty()    {        if(head==tail)            return true;        return false;    }    void pop()    {        head++;    }    node front()    {        node t=qu[head];        return t;    }};char s[105][105];int p[105][105];que q;void dfs(int x){    if(qu[x].pre!=-1)        dfs(qu[x].pre);    else        return;    if(s[qu[x].x][qu[x].y]!='.')    {        if(qu[x].x!=qu[qu[x].pre].x||qu[x].y!=qu[qu[x].pre].y)        printf("%ds:(%d,%d)->(%d,%d)\n",qu[x].time,qu[qu[x].pre].x,qu[qu[x].pre].y,qu[x].x,qu[x].y);        else        printf("%ds:FIGHT AT (%d,%d)\n",qu[x].time,qu[x].x,qu[x].y);    }    else    {        printf("%ds:(%d,%d)->(%d,%d)\n",qu[x].time,qu[qu[x].pre].x,qu[qu[x].pre].y,qu[x].x,qu[x].y);    }}int main(){    node now,next;    int i,j,n,m,tag,xx,yy;    while(scanf("%d%d",&n,&m)!=EOF)    {        memset(p,0,sizeof(p));        head=0;        tail=0;        for(i=0;i<n;i++)        {            scanf("%s",s[i]);        }        now.x=0;        now.y=0;        now.pre=-1;        now.time=0;        q.push(now);        p[0][0]=1;        tag=0;        while(!q.empty())        {            now=q.front();            if(s[now.x][now.y]>'0'&&s[now.x][now.y]<='9')            {                next=now;                next.time++;                next.pre=head;                q.push(next);                s[now.x][now.y]--;                q.pop();                continue;            }            if(now.x==n-1&&now.y==m-1)            {                tag=1;                break;            }            for(i=0;i<4;i++)            {                xx=now.x+dirx[i];                yy=now.y+diry[i];                if(xx>=0&&yy>=0&&xx<n&&yy<m&&s[xx][yy]!='X'&&!p[xx][yy])                {                    p[xx][yy]=1;                    next.x=xx;                    next.y=yy;                    next.time=now.time+1;                    next.pre=head;                    q.push(next);                }            }            q.pop();        }        if(tag)        {            int x=head;            printf("It takes %d seconds to reach the target position, let me show you the way.\n",qu[x].time);            dfs(x);        }        else            printf("God please help our poor hero.\n");        printf("FINISH\n");    }    return 0;}


阅读全文
0 0
原创粉丝点击